from generated.array import Array
from generated.base_struct import BaseStruct
from generated.formats.nif.imports import name_type_map


class BSGeometrySegmentSharedData(BaseStruct):

	__name__ = 'BSGeometrySegmentSharedData'


	def __init__(self, context, arg=0, template=None, set_default=True):
		super().__init__(context, arg, template, set_default=False)
		self.num_segments = name_type_map['Uint'](self.context, 0, None)
		self.total_segments = name_type_map['Uint'](self.context, 0, None)
		self.segment_starts = Array(self.context, 0, None, (0,), name_type_map['Uint'])
		self.per_segment_data = Array(self.context, 0, None, (0,), name_type_map['BSGeometryPerSegmentSharedData'])
		self.ssf_file = name_type_map['SizedString16'](self.context, 0, None)
		if set_default:
			self.set_defaults()

	@classmethod
	def _get_attribute_list(cls):
		yield from super()._get_attribute_list()
		yield 'num_segments', name_type_map['Uint'], (0, None), (False, None), (None, None)
		yield 'total_segments', name_type_map['Uint'], (0, None), (False, None), (None, None)
		yield 'segment_starts', Array, (0, None, (None,), name_type_map['Uint']), (False, None), (None, None)
		yield 'per_segment_data', Array, (0, None, (None,), name_type_map['BSGeometryPerSegmentSharedData']), (False, None), (None, None)
		yield 'ssf_file', name_type_map['SizedString16'], (0, None), (False, None), (None, None)

	@classmethod
	def _get_filtered_attribute_list(cls, instance, include_abstract=True):
		yield from super()._get_filtered_attribute_list(instance, include_abstract)
		yield 'num_segments', name_type_map['Uint'], (0, None), (False, None)
		yield 'total_segments', name_type_map['Uint'], (0, None), (False, None)
		yield 'segment_starts', Array, (0, None, (instance.num_segments,), name_type_map['Uint']), (False, None)
		yield 'per_segment_data', Array, (0, None, (instance.total_segments,), name_type_map['BSGeometryPerSegmentSharedData']), (False, None)
		yield 'ssf_file', name_type_map['SizedString16'], (0, None), (False, None)
