from importlib import import_module


type_module_name_map = {
	'Uint64': 'generated.formats.nif.basic',
	'Int64': 'generated.formats.nif.basic',
	'Ulittle32': 'generated.formats.nif.basic',
	'Uint': 'generated.formats.nif.basic',
	'Int': 'generated.formats.nif.basic',
	'Ushort': 'generated.formats.nif.basic',
	'Short': 'generated.formats.nif.basic',
	'Char': 'generated.formats.nif.basic',
	'Sbyte': 'generated.formats.nif.basic',
	'Byte': 'generated.formats.nif.basic',
	'Normbyte': 'generated.formats.nif.basic',
	'Bool': 'generated.formats.nif.basic',
	'BlockTypeIndex': 'generated.formats.nif.basic',
	'FileVersion': 'generated.formats.nif.basic',
	'Float': 'generated.formats.nif.basic',
	'Hfloat': 'generated.formats.nif.basic',
	'HeaderString': 'generated.formats.nif.basic',
	'LineString': 'generated.formats.nif.basic',
	'Ptr': 'generated.formats.nif.basic',
	'Ref': 'generated.formats.nif.basic',
	'StringOffset': 'generated.formats.nif.basic',
	'NiFixedString': 'generated.formats.nif.basic',
	'AccumFlags': 'generated.formats.nif.bitflagss.AccumFlags',
	'ApplyMode': 'generated.formats.nif.enums.ApplyMode',
	'TexType': 'generated.formats.nif.enums.TexType',
	'KeyType': 'generated.formats.nif.enums.KeyType',
	'OblivionHavokMaterial': 'generated.formats.nif.enums.OblivionHavokMaterial',
	'Fallout3HavokMaterial': 'generated.formats.nif.enums.Fallout3HavokMaterial',
	'SkyrimHavokMaterial': 'generated.formats.nif.enums.SkyrimHavokMaterial',
	'OblivionLayer': 'generated.formats.nif.enums.OblivionLayer',
	'Fallout3Layer': 'generated.formats.nif.enums.Fallout3Layer',
	'SkyrimLayer': 'generated.formats.nif.enums.SkyrimLayer',
	'BipedPart': 'generated.formats.nif.enums.BipedPart',
	'HkMoppCodeBuildType': 'generated.formats.nif.enums.HkMoppCodeBuildType',
	'PlatformID': 'generated.formats.nif.enums.PlatformID',
	'RendererID': 'generated.formats.nif.enums.RendererID',
	'PixelFormat': 'generated.formats.nif.enums.PixelFormat',
	'PixelTiling': 'generated.formats.nif.enums.PixelTiling',
	'PixelComponent': 'generated.formats.nif.enums.PixelComponent',
	'PixelRepresentation': 'generated.formats.nif.enums.PixelRepresentation',
	'PixelLayout': 'generated.formats.nif.enums.PixelLayout',
	'MipMapFormat': 'generated.formats.nif.enums.MipMapFormat',
	'AlphaFormat': 'generated.formats.nif.enums.AlphaFormat',
	'TexClampMode': 'generated.formats.nif.enums.TexClampMode',
	'TexFilterMode': 'generated.formats.nif.enums.TexFilterMode',
	'SourceVertexMode': 'generated.formats.nif.enums.SourceVertexMode',
	'LightingMode': 'generated.formats.nif.enums.LightingMode',
	'CycleType': 'generated.formats.nif.enums.CycleType',
	'FieldType': 'generated.formats.nif.enums.FieldType',
	'BillboardMode': 'generated.formats.nif.enums.BillboardMode',
	'StencilTestFunc': 'generated.formats.nif.enums.StencilTestFunc',
	'StencilAction': 'generated.formats.nif.enums.StencilAction',
	'StencilDrawMode': 'generated.formats.nif.enums.StencilDrawMode',
	'TestFunction': 'generated.formats.nif.enums.TestFunction',
	'AlphaFunction': 'generated.formats.nif.enums.AlphaFunction',
	'HkMotionType': 'generated.formats.nif.enums.HkMotionType',
	'HkDeactivatorType': 'generated.formats.nif.enums.HkDeactivatorType',
	'HkSolverDeactivation': 'generated.formats.nif.enums.HkSolverDeactivation',
	'HkQualityType': 'generated.formats.nif.enums.HkQualityType',
	'ForceType': 'generated.formats.nif.enums.ForceType',
	'TransformMember': 'generated.formats.nif.enums.TransformMember',
	'DecayType': 'generated.formats.nif.enums.DecayType',
	'SymmetryType': 'generated.formats.nif.enums.SymmetryType',
	'VelocityType': 'generated.formats.nif.enums.VelocityType',
	'EmitFrom': 'generated.formats.nif.enums.EmitFrom',
	'TextureType': 'generated.formats.nif.enums.TextureType',
	'CoordGenType': 'generated.formats.nif.enums.CoordGenType',
	'EndianType': 'generated.formats.nif.enums.EndianType',
	'MaterialColor': 'generated.formats.nif.enums.MaterialColor',
	'LightColor': 'generated.formats.nif.enums.LightColor',
	'ConsistencyType': 'generated.formats.nif.enums.ConsistencyType',
	'SortingMode': 'generated.formats.nif.enums.SortingMode',
	'PropagationMode': 'generated.formats.nif.enums.PropagationMode',
	'CollisionMode': 'generated.formats.nif.enums.CollisionMode',
	'BoundVolumeType': 'generated.formats.nif.enums.BoundVolumeType',
	'HkResponseType': 'generated.formats.nif.enums.HkResponseType',
	'BSDismemberBodyPartType': 'generated.formats.nif.enums.BSDismemberBodyPartType',
	'BSLightingShaderType': 'generated.formats.nif.enums.BSLightingShaderType',
	'BSShaderType155': 'generated.formats.nif.enums.BSShaderType155',
	'EffectShaderControlledVariable': 'generated.formats.nif.enums.EffectShaderControlledVariable',
	'EffectShaderControlledColor': 'generated.formats.nif.enums.EffectShaderControlledColor',
	'LightingShaderControlledFloat': 'generated.formats.nif.enums.LightingShaderControlledFloat',
	'LightingShaderControlledUShort': 'generated.formats.nif.enums.LightingShaderControlledUShort',
	'LightingShaderControlledColor': 'generated.formats.nif.enums.LightingShaderControlledColor',
	'HkConstraintType': 'generated.formats.nif.enums.HkConstraintType',
	'FogFunction': 'generated.formats.nif.enums.FogFunction',
	'AnimType': 'generated.formats.nif.enums.AnimType',
	'DitherFlags': 'generated.formats.nif.enums.DitherFlags',
	'ShadeFlags': 'generated.formats.nif.enums.ShadeFlags',
	'SpecularFlags': 'generated.formats.nif.enums.SpecularFlags',
	'WireframeFlags': 'generated.formats.nif.enums.WireframeFlags',
	'GeomMorpherFlags': 'generated.formats.nif.enums.GeomMorpherFlags',
	'TimeControllerFlags': 'generated.formats.nif.bitfields.TimeControllerFlags',
	'AlphaFlags': 'generated.formats.nif.bitfields.AlphaFlags',
	'FogFlags': 'generated.formats.nif.bitfields.FogFlags',
	'StencilFlags': 'generated.formats.nif.bitfields.StencilFlags',
	'TexturingFlags': 'generated.formats.nif.bitfields.TexturingFlags',
	'TexturingMapFlags': 'generated.formats.nif.bitfields.TexturingMapFlags',
	'VertexColorFlags': 'generated.formats.nif.bitfields.VertexColorFlags',
	'ZBufferFlags': 'generated.formats.nif.bitfields.ZBufferFlags',
	'AGDConsistencyType': 'generated.formats.nif.enums.AGDConsistencyType',
	'NiAGDDataStreamFlags': 'generated.formats.nif.bitfields.NiAGDDataStreamFlags',
	'NiNBTMethod': 'generated.formats.nif.enums.NiNBTMethod',
	'NiGeometryDataFlags': 'generated.formats.nif.bitfields.NiGeometryDataFlags',
	'BSGeometryDataFlags': 'generated.formats.nif.bitfields.BSGeometryDataFlags',
	'CollisionFilterFlags': 'generated.formats.nif.bitfields.CollisionFilterFlags',
	'SizedString': 'generated.formats.nif.nimain.structs.SizedString',
	'SizedString16': 'generated.formats.nif.nimain.structs.SizedString16',
	'String': 'generated.formats.nif.nimain.structs.String',
	'NiTFixedStringMapItem': 'generated.formats.nif.nimain.structs.NiTFixedStringMapItem',
	'NiTFixedStringMap': 'generated.formats.nif.nimain.structs.NiTFixedStringMap',
	'ByteArray': 'generated.formats.nif.nimain.structs.ByteArray',
	'ByteMatrix': 'generated.formats.nif.nimain.structs.ByteMatrix',
	'Color3': 'generated.formats.nif.nimain.structs.Color3',
	'ByteColor3': 'generated.formats.nif.nimain.structs.ByteColor3',
	'Color4': 'generated.formats.nif.nimain.structs.Color4',
	'ByteColor4': 'generated.formats.nif.nimain.structs.ByteColor4',
	'FilePath': 'generated.formats.nif.nimain.structs.FilePath',
	'Footer': 'generated.formats.nif.nimain.structs.Footer',
	'LODRange': 'generated.formats.nif.nimain.structs.LODRange',
	'MatchGroup': 'generated.formats.nif.nimain.structs.MatchGroup',
	'Vector3': 'generated.formats.nif.nimain.structs.Vector3',
	'HalfVector3': 'generated.formats.nif.nimain.structs.HalfVector3',
	'UshortVector3': 'generated.formats.nif.nimain.structs.UshortVector3',
	'ByteVector3': 'generated.formats.nif.nimain.structs.ByteVector3',
	'Vector4': 'generated.formats.nif.nimain.structs.Vector4',
	'Quaternion': 'generated.formats.nif.nimain.structs.Quaternion',
	'HkQuaternion': 'generated.formats.nif.bsmain.structs.HkQuaternion',
	'Matrix22': 'generated.formats.nif.nimain.structs.Matrix22',
	'Matrix33': 'generated.formats.nif.nimain.structs.Matrix33',
	'Matrix34': 'generated.formats.nif.nimain.structs.Matrix34',
	'Matrix44': 'generated.formats.nif.nimain.structs.Matrix44',
	'HkMatrix3': 'generated.formats.nif.bshavok.structs.HkMatrix3',
	'MipMap': 'generated.formats.nif.nimain.structs.MipMap',
	'NodeSet': 'generated.formats.nif.nianimation.structs.NodeSet',
	'ExportString': 'generated.formats.nif.bsmain.structs.ExportString',
	'SkinInfo': 'generated.formats.nif.nianimation.structs.SkinInfo',
	'SkinInfoSet': 'generated.formats.nif.nianimation.structs.SkinInfoSet',
	'BoneVertData': 'generated.formats.nif.nimain.structs.BoneVertData',
	'AVObject': 'generated.formats.nif.nimain.structs.AVObject',
	'ControlledBlock': 'generated.formats.nif.nianimation.structs.ControlledBlock',
	'BSStreamHeader': 'generated.formats.nif.bsmain.structs.BSStreamHeader',
	'Header': 'generated.formats.nif.nimain.structs.Header',
	'StringPalette': 'generated.formats.nif.nimain.structs.StringPalette',
	'Tbc': 'generated.formats.nif.nimain.structs.Tbc',
	'Key': 'generated.formats.nif.nimain.structs.Key',
	'KeyGroup': 'generated.formats.nif.nimain.structs.KeyGroup',
	'QuatKey': 'generated.formats.nif.nimain.structs.QuatKey',
	'TexCoord': 'generated.formats.nif.nimain.structs.TexCoord',
	'HalfTexCoord': 'generated.formats.nif.nimain.structs.HalfTexCoord',
	'TransformMethod': 'generated.formats.nif.enums.TransformMethod',
	'TexDesc': 'generated.formats.nif.nimain.structs.TexDesc',
	'ShaderTexDesc': 'generated.formats.nif.nimain.structs.ShaderTexDesc',
	'Triangle': 'generated.formats.nif.nimain.structs.Triangle',
	'VertexAttribute': 'generated.formats.nif.bitflagss.VertexAttribute',
	'BSVertexDesc': 'generated.formats.nif.bitfields.BSVertexDesc',
	'BSVertexData': 'generated.formats.nif.bsmain.structs.BSVertexData',
	'BSVertexDataSSE': 'generated.formats.nif.bsmain.structs.BSVertexDataSSE',
	'SkinPartition': 'generated.formats.nif.nimain.structs.SkinPartition',
	'NiPlane': 'generated.formats.nif.nimain.structs.NiPlane',
	'NiBoundAABB': 'generated.formats.nif.nimain.structs.NiBoundAABB',
	'NiBound': 'generated.formats.nif.nimain.structs.NiBound',
	'NiCurve3': 'generated.formats.nif.nimain.structs.NiCurve3',
	'NiQuatTransform': 'generated.formats.nif.nimain.structs.NiQuatTransform',
	'NiTransform': 'generated.formats.nif.nimain.structs.NiTransform',
	'FurnitureEntryPoints': 'generated.formats.nif.bitflagss.FurnitureEntryPoints',
	'AnimationType': 'generated.formats.nif.enums.AnimationType',
	'FurniturePosition': 'generated.formats.nif.bsmain.structs.FurniturePosition',
	'BhkWeldInfo': 'generated.formats.nif.bshavok.bitfields.BhkWeldInfo',
	'TriangleData': 'generated.formats.nif.bshavok.structs.TriangleData',
	'Morph': 'generated.formats.nif.nianimation.structs.Morph',
	'NiParticleInfo': 'generated.formats.nif.nimain.structs.NiParticleInfo',
	'BoneData': 'generated.formats.nif.nimain.structs.BoneData',
	'HavokFilter': 'generated.formats.nif.bshavok.structs.HavokFilter',
	'HavokMaterial': 'generated.formats.nif.bshavok.structs.HavokMaterial',
	'HkSubPartData': 'generated.formats.nif.bshavok.structs.HkSubPartData',
	'HkAabb': 'generated.formats.nif.bshavok.structs.HkAabb',
	'ConstraintPriority': 'generated.formats.nif.enums.ConstraintPriority',
	'BhkConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkConstraintCInfo',
	'BhkConstraintChainCInfo': 'generated.formats.nif.bshavok.structs.BhkConstraintChainCInfo',
	'BhkPositionConstraintMotor': 'generated.formats.nif.bshavok.structs.BhkPositionConstraintMotor',
	'BhkVelocityConstraintMotor': 'generated.formats.nif.bshavok.structs.BhkVelocityConstraintMotor',
	'BhkSpringDamperConstraintMotor': 'generated.formats.nif.bshavok.structs.BhkSpringDamperConstraintMotor',
	'HkMotorType': 'generated.formats.nif.enums.HkMotorType',
	'BhkConstraintMotorCInfo': 'generated.formats.nif.bshavok.structs.BhkConstraintMotorCInfo',
	'BhkRagdollConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkRagdollConstraintCInfo',
	'BhkLimitedHingeConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkLimitedHingeConstraintCInfo',
	'BhkHingeConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkHingeConstraintCInfo',
	'BhkBallAndSocketConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkBallAndSocketConstraintCInfo',
	'BhkPrismaticConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkPrismaticConstraintCInfo',
	'BhkStiffSpringConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkStiffSpringConstraintCInfo',
	'OldSkinData': 'generated.formats.nif.nimain.structs.OldSkinData',
	'ImageType': 'generated.formats.nif.nimain.enums.ImageType',
	'BoxBV': 'generated.formats.nif.nimain.structs.BoxBV',
	'CapsuleBV': 'generated.formats.nif.nimain.structs.CapsuleBV',
	'HalfSpaceBV': 'generated.formats.nif.nimain.structs.HalfSpaceBV',
	'BoundingVolume': 'generated.formats.nif.nimain.structs.BoundingVolume',
	'UnionBV': 'generated.formats.nif.nimain.structs.UnionBV',
	'MorphWeight': 'generated.formats.nif.nianimation.structs.MorphWeight',
	'BoneTransform': 'generated.formats.nif.bsmain.structs.BoneTransform',
	'BonePose': 'generated.formats.nif.bsmain.structs.BonePose',
	'DecalVectorArray': 'generated.formats.nif.bsmain.structs.DecalVectorArray',
	'BSPartFlag': 'generated.formats.nif.bsmain.bitflagss.BSPartFlag',
	'BodyPartList': 'generated.formats.nif.bsmain.structs.BodyPartList',
	'BoneLOD': 'generated.formats.nif.bsmain.structs.BoneLOD',
	'BhkMeshMaterial': 'generated.formats.nif.bshavok.structs.BhkMeshMaterial',
	'BhkCMSBigTri': 'generated.formats.nif.bshavok.structs.BhkCMSBigTri',
	'BhkQsTransform': 'generated.formats.nif.bshavok.structs.BhkQsTransform',
	'BhkCMSChunk': 'generated.formats.nif.bshavok.structs.BhkCMSChunk',
	'BhkMalleableConstraintCInfo': 'generated.formats.nif.bshavok.structs.BhkMalleableConstraintCInfo',
	'BhkWrappedConstraintData': 'generated.formats.nif.bshavok.structs.BhkWrappedConstraintData',
	'NiObject': 'generated.formats.nif.nimain.niobjects.NiObject',
	'Ni3DsAlphaAnimator': 'generated.formats.nif.nilegacy.niobjects.Ni3DsAlphaAnimator',
	'Ni3DsAnimationNode': 'generated.formats.nif.nilegacy.niobjects.Ni3DsAnimationNode',
	'Ni3DsColorAnimator': 'generated.formats.nif.nilegacy.niobjects.Ni3DsColorAnimator',
	'Ni3DsMorphShape': 'generated.formats.nif.nilegacy.niobjects.Ni3DsMorphShape',
	'Ni3DsParticleSystem': 'generated.formats.nif.nilegacy.niobjects.Ni3DsParticleSystem',
	'Ni3DsPathController': 'generated.formats.nif.nilegacy.niobjects.Ni3DsPathController',
	'NiParticleModifier': 'generated.formats.nif.nilegacy.niobjects.NiParticleModifier',
	'NiPSysCollider': 'generated.formats.nif.niparticle.niobjects.NiPSysCollider',
	'BroadPhaseType': 'generated.formats.nif.enums.BroadPhaseType',
	'BhkRefObject': 'generated.formats.nif.bshavok.niobjects.BhkRefObject',
	'BhkSerializable': 'generated.formats.nif.bshavok.niobjects.BhkSerializable',
	'BhkWorldObjCInfoProperty': 'generated.formats.nif.bshavok.structs.BhkWorldObjCInfoProperty',
	'BhkWorldObjectCInfo': 'generated.formats.nif.bshavok.structs.BhkWorldObjectCInfo',
	'BhkWorldObject': 'generated.formats.nif.bshavok.niobjects.BhkWorldObject',
	'BhkPhantom': 'generated.formats.nif.bshavok.niobjects.BhkPhantom',
	'BhkAabbPhantom': 'generated.formats.nif.bshavok.niobjects.BhkAabbPhantom',
	'BhkShapePhantom': 'generated.formats.nif.bshavok.niobjects.BhkShapePhantom',
	'BhkSimpleShapePhantom': 'generated.formats.nif.bshavok.niobjects.BhkSimpleShapePhantom',
	'BhkEntityCInfo': 'generated.formats.nif.bshavok.structs.BhkEntityCInfo',
	'BhkEntity': 'generated.formats.nif.bshavok.niobjects.BhkEntity',
	'BhkRigidBodyCInfo550660': 'generated.formats.nif.bshavok.structs.BhkRigidBodyCInfo550660',
	'BhkRigidBodyCInfo2010': 'generated.formats.nif.bshavok.structs.BhkRigidBodyCInfo2010',
	'BhkRigidBodyCInfo2014': 'generated.formats.nif.bshavok.structs.BhkRigidBodyCInfo2014',
	'BhkRigidBody': 'generated.formats.nif.bshavok.niobjects.BhkRigidBody',
	'BhkRigidBodyT': 'generated.formats.nif.bshavok.niobjects.BhkRigidBodyT',
	'BhkAction': 'generated.formats.nif.bshavok.niobjects.BhkAction',
	'BhkUnaryAction': 'generated.formats.nif.bshavok.niobjects.BhkUnaryAction',
	'BhkBinaryAction': 'generated.formats.nif.bshavok.niobjects.BhkBinaryAction',
	'BhkConstraint': 'generated.formats.nif.bshavok.niobjects.BhkConstraint',
	'BhkLimitedHingeConstraint': 'generated.formats.nif.bshavok.niobjects.BhkLimitedHingeConstraint',
	'BhkMalleableConstraint': 'generated.formats.nif.bshavok.niobjects.BhkMalleableConstraint',
	'BhkStiffSpringConstraint': 'generated.formats.nif.bshavok.niobjects.BhkStiffSpringConstraint',
	'BhkRagdollConstraint': 'generated.formats.nif.bshavok.niobjects.BhkRagdollConstraint',
	'BhkPrismaticConstraint': 'generated.formats.nif.bshavok.niobjects.BhkPrismaticConstraint',
	'BhkHingeConstraint': 'generated.formats.nif.bshavok.niobjects.BhkHingeConstraint',
	'BhkBallAndSocketConstraint': 'generated.formats.nif.bshavok.niobjects.BhkBallAndSocketConstraint',
	'BhkBallSocketConstraintChain': 'generated.formats.nif.bshavok.niobjects.BhkBallSocketConstraintChain',
	'BhkShape': 'generated.formats.nif.bshavok.niobjects.BhkShape',
	'BhkTransformShape': 'generated.formats.nif.bshavok.niobjects.BhkTransformShape',
	'BhkConvexShapeBase': 'generated.formats.nif.bshavok.niobjects.BhkConvexShapeBase',
	'BhkSphereRepShape': 'generated.formats.nif.bshavok.niobjects.BhkSphereRepShape',
	'BhkConvexShape': 'generated.formats.nif.bshavok.niobjects.BhkConvexShape',
	'BhkHeightFieldShape': 'generated.formats.nif.bshavok.niobjects.BhkHeightFieldShape',
	'BhkPlaneShape': 'generated.formats.nif.bshavok.niobjects.BhkPlaneShape',
	'BhkSphereShape': 'generated.formats.nif.bshavok.niobjects.BhkSphereShape',
	'BhkCylinderShape': 'generated.formats.nif.bshavok.niobjects.BhkCylinderShape',
	'BhkCapsuleShape': 'generated.formats.nif.bshavok.niobjects.BhkCapsuleShape',
	'BhkBoxShape': 'generated.formats.nif.bshavok.niobjects.BhkBoxShape',
	'BhkConvexVerticesShape': 'generated.formats.nif.bshavok.niobjects.BhkConvexVerticesShape',
	'BhkConvexTransformShape': 'generated.formats.nif.bshavok.niobjects.BhkConvexTransformShape',
	'BhkConvexSweepShape': 'generated.formats.nif.bshavok.niobjects.BhkConvexSweepShape',
	'BhkMultiSphereShape': 'generated.formats.nif.bshavok.niobjects.BhkMultiSphereShape',
	'BhkBvTreeShape': 'generated.formats.nif.bshavok.niobjects.BhkBvTreeShape',
	'HkpMoppCode': 'generated.formats.nif.bshavok.structs.HkpMoppCode',
	'BhkMoppBvTreeShape': 'generated.formats.nif.bshavok.niobjects.BhkMoppBvTreeShape',
	'BhkShapeCollection': 'generated.formats.nif.bshavok.niobjects.BhkShapeCollection',
	'BhkListShape': 'generated.formats.nif.bshavok.niobjects.BhkListShape',
	'BhkMeshShape': 'generated.formats.nif.bshavok.niobjects.BhkMeshShape',
	'BhkPackedNiTriStripsShape': 'generated.formats.nif.bshavok.niobjects.BhkPackedNiTriStripsShape',
	'BhkNiTriStripsShape': 'generated.formats.nif.bshavok.niobjects.BhkNiTriStripsShape',
	'NiExtraData': 'generated.formats.nif.nimain.niobjects.NiExtraData',
	'NiInterpolator': 'generated.formats.nif.nianimation.niobjects.NiInterpolator',
	'NiKeyBasedInterpolator': 'generated.formats.nif.nianimation.niobjects.NiKeyBasedInterpolator',
	'NiColorInterpolator': 'generated.formats.nif.nianimation.niobjects.NiColorInterpolator',
	'NiFloatInterpolator': 'generated.formats.nif.nianimation.niobjects.NiFloatInterpolator',
	'NiTransformInterpolator': 'generated.formats.nif.nianimation.niobjects.NiTransformInterpolator',
	'NiPoint3Interpolator': 'generated.formats.nif.nianimation.niobjects.NiPoint3Interpolator',
	'PathFlags': 'generated.formats.nif.bitflagss.PathFlags',
	'NiPathInterpolator': 'generated.formats.nif.nianimation.niobjects.NiPathInterpolator',
	'NiBoolInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBoolInterpolator',
	'NiBoolTimelineInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBoolTimelineInterpolator',
	'InterpBlendFlags': 'generated.formats.nif.bitflagss.InterpBlendFlags',
	'InterpBlendItem': 'generated.formats.nif.nianimation.structs.InterpBlendItem',
	'NiBlendInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBlendInterpolator',
	'NiBSplineInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineInterpolator',
	'LegacyExtraData': 'generated.formats.nif.nilegacy.structs.LegacyExtraData',
	'NiObjectNET': 'generated.formats.nif.nimain.niobjects.NiObjectNET',
	'NiCollisionObject': 'generated.formats.nif.nimain.niobjects.NiCollisionObject',
	'NiCollisionData': 'generated.formats.nif.nimain.niobjects.NiCollisionData',
	'BhkCOFlags': 'generated.formats.nif.bshavok.bitflagss.BhkCOFlags',
	'BhkNiCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkNiCollisionObject',
	'BhkCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkCollisionObject',
	'BhkBlendCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkBlendCollisionObject',
	'BhkPCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkPCollisionObject',
	'BhkSPCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkSPCollisionObject',
	'NiAVObject': 'generated.formats.nif.nimain.niobjects.NiAVObject',
	'NiDynamicEffect': 'generated.formats.nif.nimain.niobjects.NiDynamicEffect',
	'NiLight': 'generated.formats.nif.nimain.niobjects.NiLight',
	'NiProperty': 'generated.formats.nif.nimain.niobjects.NiProperty',
	'NiTransparentProperty': 'generated.formats.nif.nilegacy.niobjects.NiTransparentProperty',
	'NiPSysModifierOrder': 'generated.formats.nif.enums.NiPSysModifierOrder',
	'NiPSysModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysModifier',
	'NiPSysEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitter',
	'NiPSysVolumeEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysVolumeEmitter',
	'NiTimeController': 'generated.formats.nif.nimain.niobjects.NiTimeController',
	'NiInterpController': 'generated.formats.nif.nianimation.niobjects.NiInterpController',
	'NiMultiTargetTransformController': 'generated.formats.nif.nianimation.niobjects.NiMultiTargetTransformController',
	'NiGeomMorpherController': 'generated.formats.nif.nianimation.niobjects.NiGeomMorpherController',
	'NiMorphController': 'generated.formats.nif.nilegacy.niobjects.NiMorphController',
	'NiMorpherController': 'generated.formats.nif.nianimation.niobjects.NiMorpherController',
	'NiSingleInterpController': 'generated.formats.nif.nianimation.niobjects.NiSingleInterpController',
	'NiKeyframeController': 'generated.formats.nif.nianimation.niobjects.NiKeyframeController',
	'NiTransformController': 'generated.formats.nif.nianimation.niobjects.NiTransformController',
	'NiPSysModifierCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysModifierCtlr',
	'NiPSysEmitterCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterCtlr',
	'NiPSysModifierBoolCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysModifierBoolCtlr',
	'NiPSysModifierActiveCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysModifierActiveCtlr',
	'NiPSysModifierFloatCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysModifierFloatCtlr',
	'NiPSysEmitterDeclinationCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterDeclinationCtlr',
	'NiPSysEmitterDeclinationVarCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterDeclinationVarCtlr',
	'NiPSysEmitterInitialRadiusCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterInitialRadiusCtlr',
	'NiPSysEmitterLifeSpanCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterLifeSpanCtlr',
	'NiPSysEmitterSpeedCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterSpeedCtlr',
	'NiPSysGravityStrengthCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysGravityStrengthCtlr',
	'NiFloatInterpController': 'generated.formats.nif.nianimation.niobjects.NiFloatInterpController',
	'NiFlipController': 'generated.formats.nif.nianimation.niobjects.NiFlipController',
	'NiAlphaController': 'generated.formats.nif.nianimation.niobjects.NiAlphaController',
	'NiTextureTransformController': 'generated.formats.nif.nianimation.niobjects.NiTextureTransformController',
	'NiLightDimmerController': 'generated.formats.nif.nianimation.niobjects.NiLightDimmerController',
	'NiBoolInterpController': 'generated.formats.nif.nianimation.niobjects.NiBoolInterpController',
	'NiVisController': 'generated.formats.nif.nianimation.niobjects.NiVisController',
	'NiPoint3InterpController': 'generated.formats.nif.nianimation.niobjects.NiPoint3InterpController',
	'NiMaterialColorController': 'generated.formats.nif.nianimation.niobjects.NiMaterialColorController',
	'NiLightColorController': 'generated.formats.nif.nianimation.niobjects.NiLightColorController',
	'NiExtraDataController': 'generated.formats.nif.nianimation.niobjects.NiExtraDataController',
	'NiColorExtraDataController': 'generated.formats.nif.nianimation.niobjects.NiColorExtraDataController',
	'NiFloatExtraDataController': 'generated.formats.nif.nianimation.niobjects.NiFloatExtraDataController',
	'NiFloatsExtraDataController': 'generated.formats.nif.nianimation.niobjects.NiFloatsExtraDataController',
	'NiFloatsExtraDataPoint3Controller': 'generated.formats.nif.nianimation.niobjects.NiFloatsExtraDataPoint3Controller',
	'NiBoneLODController': 'generated.formats.nif.nianimation.niobjects.NiBoneLODController',
	'NiBSBoneLODController': 'generated.formats.nif.bsanimation.niobjects.NiBSBoneLODController',
	'MaterialData': 'generated.formats.nif.nimain.structs.MaterialData',
	'NiGeometry': 'generated.formats.nif.nimain.niobjects.NiGeometry',
	'NiTriBasedGeom': 'generated.formats.nif.nimain.niobjects.NiTriBasedGeom',
	'NiGeometryData': 'generated.formats.nif.nimain.niobjects.NiGeometryData',
	'AbstractAdditionalGeometryData': 'generated.formats.nif.nimain.niobjects.AbstractAdditionalGeometryData',
	'NiTriBasedGeomData': 'generated.formats.nif.nimain.niobjects.NiTriBasedGeomData',
	'BhkBlendController': 'generated.formats.nif.bshavok.niobjects.BhkBlendController',
	'BSBound': 'generated.formats.nif.bsmain.niobjects.BSBound',
	'BSFurnitureMarker': 'generated.formats.nif.bsmain.niobjects.BSFurnitureMarker',
	'BSParentVelocityModifier': 'generated.formats.nif.bsparticle.niobjects.BSParentVelocityModifier',
	'BSPSysArrayEmitter': 'generated.formats.nif.bsparticle.niobjects.BSPSysArrayEmitter',
	'BSWindModifier': 'generated.formats.nif.bsparticle.niobjects.BSWindModifier',
	'HkPackedNiTriStripsData': 'generated.formats.nif.bshavok.niobjects.HkPackedNiTriStripsData',
	'NiAlphaProperty': 'generated.formats.nif.nimain.niobjects.NiAlphaProperty',
	'NiAmbientLight': 'generated.formats.nif.nimain.niobjects.NiAmbientLight',
	'AspectFlags': 'generated.formats.nif.bitflagss.AspectFlags',
	'NiParticlesData': 'generated.formats.nif.nimain.niobjects.NiParticlesData',
	'NiRotatingParticlesData': 'generated.formats.nif.nilegacy.niobjects.NiRotatingParticlesData',
	'NiAutoNormalParticlesData': 'generated.formats.nif.nilegacy.niobjects.NiAutoNormalParticlesData',
	'NiPSysData': 'generated.formats.nif.niparticle.niobjects.NiPSysData',
	'NiMeshPSysData': 'generated.formats.nif.niparticle.niobjects.NiMeshPSysData',
	'NiBinaryExtraData': 'generated.formats.nif.nimain.niobjects.NiBinaryExtraData',
	'NiBinaryVoxelExtraData': 'generated.formats.nif.nilegacy.niobjects.NiBinaryVoxelExtraData',
	'NiBinaryVoxelData': 'generated.formats.nif.nilegacy.niobjects.NiBinaryVoxelData',
	'NiBlendBoolInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBlendBoolInterpolator',
	'NiBlendFloatInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBlendFloatInterpolator',
	'NiBlendPoint3Interpolator': 'generated.formats.nif.nianimation.niobjects.NiBlendPoint3Interpolator',
	'NiBlendTransformInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBlendTransformInterpolator',
	'NiBoolData': 'generated.formats.nif.nianimation.niobjects.NiBoolData',
	'NiBooleanExtraData': 'generated.formats.nif.nimain.niobjects.NiBooleanExtraData',
	'NiBSplineBasisData': 'generated.formats.nif.nianimation.niobjects.NiBSplineBasisData',
	'NiBSplineFloatInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineFloatInterpolator',
	'NiBSplineCompFloatInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompFloatInterpolator',
	'NiBSplinePoint3Interpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplinePoint3Interpolator',
	'NiBSplineCompPoint3Interpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompPoint3Interpolator',
	'NiBSplineTransformInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineTransformInterpolator',
	'NiBSplineCompTransformInterpolator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompTransformInterpolator',
	'BSRotAccumTransfInterpolator': 'generated.formats.nif.bsanimation.niobjects.BSRotAccumTransfInterpolator',
	'NiBSplineData': 'generated.formats.nif.nianimation.niobjects.NiBSplineData',
	'NiCamera': 'generated.formats.nif.nimain.niobjects.NiCamera',
	'NiColorData': 'generated.formats.nif.nianimation.niobjects.NiColorData',
	'NiColorExtraData': 'generated.formats.nif.nimain.niobjects.NiColorExtraData',
	'NiControllerManager': 'generated.formats.nif.nianimation.niobjects.NiControllerManager',
	'NiSequence': 'generated.formats.nif.nianimation.niobjects.NiSequence',
	'NiControllerSequence': 'generated.formats.nif.nianimation.niobjects.NiControllerSequence',
	'NiAVObjectPalette': 'generated.formats.nif.nimain.niobjects.NiAVObjectPalette',
	'NiDefaultAVObjectPalette': 'generated.formats.nif.nimain.niobjects.NiDefaultAVObjectPalette',
	'NiDirectionalLight': 'generated.formats.nif.nimain.niobjects.NiDirectionalLight',
	'NiDitherProperty': 'generated.formats.nif.nimain.niobjects.NiDitherProperty',
	'NiRollController': 'generated.formats.nif.nianimation.niobjects.NiRollController',
	'NiFloatData': 'generated.formats.nif.nianimation.niobjects.NiFloatData',
	'NiFloatExtraData': 'generated.formats.nif.nimain.niobjects.NiFloatExtraData',
	'NiFloatsExtraData': 'generated.formats.nif.nimain.niobjects.NiFloatsExtraData',
	'NiFogProperty': 'generated.formats.nif.nimain.niobjects.NiFogProperty',
	'NiGravity': 'generated.formats.nif.nilegacy.niobjects.NiGravity',
	'NiIntegerExtraData': 'generated.formats.nif.nimain.niobjects.NiIntegerExtraData',
	'BSXFlags': 'generated.formats.nif.bsmain.niobjects.BSXFlags',
	'NiIntegersExtraData': 'generated.formats.nif.nimain.niobjects.NiIntegersExtraData',
	'BSKeyframeController': 'generated.formats.nif.bsanimation.niobjects.BSKeyframeController',
	'NiKeyframeData': 'generated.formats.nif.nianimation.niobjects.NiKeyframeData',
	'LookAtFlags': 'generated.formats.nif.bitflagss.LookAtFlags',
	'NiLookAtController': 'generated.formats.nif.nianimation.niobjects.NiLookAtController',
	'NiLookAtInterpolator': 'generated.formats.nif.nianimation.niobjects.NiLookAtInterpolator',
	'NiMaterialProperty': 'generated.formats.nif.nimain.niobjects.NiMaterialProperty',
	'NiMorphData': 'generated.formats.nif.nianimation.niobjects.NiMorphData',
	'NiNode': 'generated.formats.nif.nimain.niobjects.NiNode',
	'NiBone': 'generated.formats.nif.nilegacy.niobjects.NiBone',
	'NiCollisionSwitch': 'generated.formats.nif.nilegacy.niobjects.NiCollisionSwitch',
	'AvoidNode': 'generated.formats.nif.bslegacy.niobjects.AvoidNode',
	'FxWidget': 'generated.formats.nif.nicustom.niobjects.FxWidget',
	'FxButton': 'generated.formats.nif.nicustom.niobjects.FxButton',
	'FxRadioButton': 'generated.formats.nif.nicustom.niobjects.FxRadioButton',
	'NiBillboardNode': 'generated.formats.nif.nimain.niobjects.NiBillboardNode',
	'NiBSAnimationNode': 'generated.formats.nif.bslegacy.niobjects.NiBSAnimationNode',
	'NiBSParticleNode': 'generated.formats.nif.bslegacy.niobjects.NiBSParticleNode',
	'NiSwitchFlags': 'generated.formats.nif.bitflagss.NiSwitchFlags',
	'NiSwitchNode': 'generated.formats.nif.nimain.niobjects.NiSwitchNode',
	'NiLODNode': 'generated.formats.nif.nimain.niobjects.NiLODNode',
	'NiPalette': 'generated.formats.nif.nimain.niobjects.NiPalette',
	'NiParticleBomb': 'generated.formats.nif.nilegacy.niobjects.NiParticleBomb',
	'NiParticleColorModifier': 'generated.formats.nif.nilegacy.niobjects.NiParticleColorModifier',
	'NiParticleGrowFade': 'generated.formats.nif.nilegacy.niobjects.NiParticleGrowFade',
	'NiParticleMeshModifier': 'generated.formats.nif.nilegacy.niobjects.NiParticleMeshModifier',
	'NiParticleRotation': 'generated.formats.nif.nilegacy.niobjects.NiParticleRotation',
	'NiParticles': 'generated.formats.nif.nimain.niobjects.NiParticles',
	'NiAutoNormalParticles': 'generated.formats.nif.nilegacy.niobjects.NiAutoNormalParticles',
	'NiParticleMeshes': 'generated.formats.nif.nilegacy.niobjects.NiParticleMeshes',
	'NiParticleMeshesData': 'generated.formats.nif.nilegacy.niobjects.NiParticleMeshesData',
	'NiParticleSystem': 'generated.formats.nif.niparticle.niobjects.NiParticleSystem',
	'NiMeshParticleSystem': 'generated.formats.nif.niparticle.niobjects.NiMeshParticleSystem',
	'NiEmitterModifier': 'generated.formats.nif.nilegacy.niobjects.NiEmitterModifier',
	'NiParticleSystemController': 'generated.formats.nif.nilegacy.niobjects.NiParticleSystemController',
	'NiBSPArrayController': 'generated.formats.nif.bslegacy.niobjects.NiBSPArrayController',
	'NiPathController': 'generated.formats.nif.nianimation.niobjects.NiPathController',
	'PixelFormatComponent': 'generated.formats.nif.nimain.structs.PixelFormatComponent',
	'NiPixelFormat': 'generated.formats.nif.nimain.niobjects.NiPixelFormat',
	'NiPersistentSrcTextureRendererData': 'generated.formats.nif.nimain.niobjects.NiPersistentSrcTextureRendererData',
	'NiPixelData': 'generated.formats.nif.nimain.niobjects.NiPixelData',
	'NiParticleCollider': 'generated.formats.nif.nilegacy.niobjects.NiParticleCollider',
	'NiPlanarCollider': 'generated.formats.nif.nilegacy.niobjects.NiPlanarCollider',
	'NiPointLight': 'generated.formats.nif.nimain.niobjects.NiPointLight',
	'NiPosData': 'generated.formats.nif.nianimation.niobjects.NiPosData',
	'NiRotData': 'generated.formats.nif.nianimation.niobjects.NiRotData',
	'NiPSysAgeDeathModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysAgeDeathModifier',
	'NiPSysBombModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysBombModifier',
	'NiPSysBoundUpdateModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysBoundUpdateModifier',
	'NiPSysBoxEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysBoxEmitter',
	'NiPSysColliderManager': 'generated.formats.nif.niparticle.niobjects.NiPSysColliderManager',
	'NiPSysColorModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysColorModifier',
	'NiPSysCylinderEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysCylinderEmitter',
	'NiPSysDragModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysDragModifier',
	'NiPSysEmitterCtlrData': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterCtlrData',
	'NiPSysGravityModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysGravityModifier',
	'NiPSysGrowFadeModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysGrowFadeModifier',
	'NiPSysMeshEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysMeshEmitter',
	'NiPSysMeshUpdateModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysMeshUpdateModifier',
	'BSPSysInheritVelocityModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysInheritVelocityModifier',
	'BSPSysHavokUpdateModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysHavokUpdateModifier',
	'BSPSysRecycleBoundModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysRecycleBoundModifier',
	'BSPSysSubTexModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysSubTexModifier',
	'NiPSysPlanarCollider': 'generated.formats.nif.niparticle.niobjects.NiPSysPlanarCollider',
	'NiPSysSphericalCollider': 'generated.formats.nif.niparticle.niobjects.NiPSysSphericalCollider',
	'NiPSysPositionModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysPositionModifier',
	'NiPSysResetOnLoopCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysResetOnLoopCtlr',
	'NiPSysRotationModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysRotationModifier',
	'NiPSysSpawnModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysSpawnModifier',
	'NiPSysPartSpawnModifier': 'generated.formats.nif.nicustom.niobjects.NiPSysPartSpawnModifier',
	'NiPSysSphereEmitter': 'generated.formats.nif.niparticle.niobjects.NiPSysSphereEmitter',
	'NiPSysUpdateCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysUpdateCtlr',
	'NiPSysFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysFieldModifier',
	'NiPSysVortexFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysVortexFieldModifier',
	'NiPSysGravityFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysGravityFieldModifier',
	'NiPSysDragFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysDragFieldModifier',
	'NiPSysTurbulenceFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysTurbulenceFieldModifier',
	'BSPSysLODModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysLODModifier',
	'BSPSysScaleModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysScaleModifier',
	'NiPSysFieldMagnitudeCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysFieldMagnitudeCtlr',
	'NiPSysFieldAttenuationCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysFieldAttenuationCtlr',
	'NiPSysFieldMaxDistanceCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysFieldMaxDistanceCtlr',
	'NiPSysAirFieldAirFrictionCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysAirFieldAirFrictionCtlr',
	'NiPSysAirFieldInheritVelocityCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysAirFieldInheritVelocityCtlr',
	'NiPSysAirFieldSpreadCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysAirFieldSpreadCtlr',
	'NiPSysInitialRotSpeedCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysInitialRotSpeedCtlr',
	'NiPSysInitialRotSpeedVarCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysInitialRotSpeedVarCtlr',
	'NiPSysInitialRotAngleCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysInitialRotAngleCtlr',
	'NiPSysInitialRotAngleVarCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysInitialRotAngleVarCtlr',
	'NiPSysEmitterPlanarAngleCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterPlanarAngleCtlr',
	'NiPSysEmitterPlanarAngleVarCtlr': 'generated.formats.nif.niparticle.niobjects.NiPSysEmitterPlanarAngleVarCtlr',
	'NiPSysAirFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysAirFieldModifier',
	'NiPSysTrailEmitter': 'generated.formats.nif.nicustom.niobjects.NiPSysTrailEmitter',
	'NiLightIntensityController': 'generated.formats.nif.nianimation.niobjects.NiLightIntensityController',
	'NiPSysRadialFieldModifier': 'generated.formats.nif.niparticle.niobjects.NiPSysRadialFieldModifier',
	'NiLODData': 'generated.formats.nif.nimain.niobjects.NiLODData',
	'NiRangeLODData': 'generated.formats.nif.nimain.niobjects.NiRangeLODData',
	'NiScreenLODData': 'generated.formats.nif.nimain.niobjects.NiScreenLODData',
	'NiRotatingParticles': 'generated.formats.nif.nilegacy.niobjects.NiRotatingParticles',
	'NiSequenceStreamHelper': 'generated.formats.nif.nianimation.niobjects.NiSequenceStreamHelper',
	'NiShadeProperty': 'generated.formats.nif.nimain.niobjects.NiShadeProperty',
	'NiSkinData': 'generated.formats.nif.nimain.niobjects.NiSkinData',
	'NiSkinInstance': 'generated.formats.nif.nimain.niobjects.NiSkinInstance',
	'NiTriShapeSkinController': 'generated.formats.nif.nilegacy.niobjects.NiTriShapeSkinController',
	'NiSkinPartition': 'generated.formats.nif.nimain.niobjects.NiSkinPartition',
	'NiTexture': 'generated.formats.nif.nimain.niobjects.NiTexture',
	'FormatPrefs': 'generated.formats.nif.nimain.structs.FormatPrefs',
	'NiSourceTexture': 'generated.formats.nif.nimain.niobjects.NiSourceTexture',
	'NiSpecularProperty': 'generated.formats.nif.nimain.niobjects.NiSpecularProperty',
	'NiSphericalCollider': 'generated.formats.nif.nilegacy.niobjects.NiSphericalCollider',
	'NiSpotLight': 'generated.formats.nif.nimain.niobjects.NiSpotLight',
	'NiStencilProperty': 'generated.formats.nif.nimain.niobjects.NiStencilProperty',
	'NiStringExtraData': 'generated.formats.nif.nimain.niobjects.NiStringExtraData',
	'NiStringPalette': 'generated.formats.nif.nimain.niobjects.NiStringPalette',
	'NiStringsExtraData': 'generated.formats.nif.nimain.niobjects.NiStringsExtraData',
	'NiTextKeyExtraData': 'generated.formats.nif.nimain.niobjects.NiTextKeyExtraData',
	'NiTextureEffect': 'generated.formats.nif.nimain.niobjects.NiTextureEffect',
	'NiTextureModeProperty': 'generated.formats.nif.nilegacy.niobjects.NiTextureModeProperty',
	'NiImage': 'generated.formats.nif.nilegacy.niobjects.NiImage',
	'NiTextureProperty': 'generated.formats.nif.nilegacy.niobjects.NiTextureProperty',
	'NiTexturingProperty': 'generated.formats.nif.nimain.niobjects.NiTexturingProperty',
	'NiMultiTextureProperty': 'generated.formats.nif.nilegacy.niobjects.NiMultiTextureProperty',
	'NiTransformData': 'generated.formats.nif.nianimation.niobjects.NiTransformData',
	'NiTriShape': 'generated.formats.nif.nimain.niobjects.NiTriShape',
	'NiTriShapeData': 'generated.formats.nif.nimain.niobjects.NiTriShapeData',
	'NiTriStrips': 'generated.formats.nif.nimain.niobjects.NiTriStrips',
	'NiTriStripsData': 'generated.formats.nif.nimain.niobjects.NiTriStripsData',
	'NiEnvMappedTriShape': 'generated.formats.nif.nilegacy.niobjects.NiEnvMappedTriShape',
	'NiEnvMappedTriShapeData': 'generated.formats.nif.nilegacy.niobjects.NiEnvMappedTriShapeData',
	'NiBezierTriangle4': 'generated.formats.nif.nilegacy.niobjects.NiBezierTriangle4',
	'NiBezierMesh': 'generated.formats.nif.nilegacy.niobjects.NiBezierMesh',
	'NiClod': 'generated.formats.nif.nilegacy.niobjects.NiClod',
	'NiClodData': 'generated.formats.nif.nilegacy.niobjects.NiClodData',
	'NiClodSkinInstance': 'generated.formats.nif.nilegacy.niobjects.NiClodSkinInstance',
	'NiUVController': 'generated.formats.nif.nianimation.niobjects.NiUVController',
	'NiUVData': 'generated.formats.nif.nianimation.niobjects.NiUVData',
	'NiVectorExtraData': 'generated.formats.nif.nimain.niobjects.NiVectorExtraData',
	'NiVertexColorProperty': 'generated.formats.nif.nimain.niobjects.NiVertexColorProperty',
	'NiVertWeightsExtraData': 'generated.formats.nif.nimain.niobjects.NiVertWeightsExtraData',
	'NiVisData': 'generated.formats.nif.nianimation.niobjects.NiVisData',
	'NiWireframeProperty': 'generated.formats.nif.nimain.niobjects.NiWireframeProperty',
	'NiZBufferProperty': 'generated.formats.nif.nimain.niobjects.NiZBufferProperty',
	'RootCollisionNode': 'generated.formats.nif.bslegacy.niobjects.RootCollisionNode',
	'NiRawImageData': 'generated.formats.nif.nilegacy.niobjects.NiRawImageData',
	'NiAccumulator': 'generated.formats.nif.nimain.niobjects.NiAccumulator',
	'NiSortAdjustNode': 'generated.formats.nif.nimain.niobjects.NiSortAdjustNode',
	'NiSourceCubeMap': 'generated.formats.nif.nilegacy.niobjects.NiSourceCubeMap',
	'NiPhysXScene': 'generated.formats.nif.niphysx.niobjects.NiPhysXScene',
	'NiSceneDescNxBroadPhaseType': 'generated.formats.nif.enums.NiSceneDescNxBroadPhaseType',
	'NiSceneDescNxHwPipelineSpec': 'generated.formats.nif.enums.NiSceneDescNxHwPipelineSpec',
	'NiSceneDescNxHwSceneType': 'generated.formats.nif.enums.NiSceneDescNxHwSceneType',
	'NxTimeStepMethod': 'generated.formats.nif.enums.NxTimeStepMethod',
	'NxSimulationType': 'generated.formats.nif.enums.NxSimulationType',
	'NxBroadPhaseType': 'generated.formats.nif.enums.NxBroadPhaseType',
	'NxFilterOp': 'generated.formats.nif.enums.NxFilterOp',
	'NxThreadPriority': 'generated.formats.nif.enums.NxThreadPriority',
	'NxPruningStructure': 'generated.formats.nif.enums.NxPruningStructure',
	'NxCompartmentType': 'generated.formats.nif.enums.NxCompartmentType',
	'NxDeviceCode': 'generated.formats.nif.enums.NxDeviceCode',
	'NxBodyFlag': 'generated.formats.nif.bitflagss.NxBodyFlag',
	'NiPhysXMaterialDescMap': 'generated.formats.nif.niphysx.structs.NiPhysXMaterialDescMap',
	'NxCompartmentDescMap': 'generated.formats.nif.niphysx.structs.NxCompartmentDescMap',
	'NiPhysXSceneDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXSceneDesc',
	'NiPhysXProp': 'generated.formats.nif.niphysx.niobjects.NiPhysXProp',
	'NiPhysXPropDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXPropDesc',
	'NiPhysXActorDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXActorDesc',
	'PhysXBodyStoredVels': 'generated.formats.nif.niphysx.structs.PhysXBodyStoredVels',
	'NiPhysXBodyDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXBodyDesc',
	'NxJointType': 'generated.formats.nif.enums.NxJointType',
	'NxD6JointMotion': 'generated.formats.nif.enums.NxD6JointMotion',
	'NxD6JointDriveType': 'generated.formats.nif.enums.NxD6JointDriveType',
	'NxJointProjectionMode': 'generated.formats.nif.enums.NxJointProjectionMode',
	'NiPhysXJointActor': 'generated.formats.nif.niphysx.structs.NiPhysXJointActor',
	'NxJointLimitSoftDesc': 'generated.formats.nif.niphysx.structs.NxJointLimitSoftDesc',
	'NxJointDriveDesc': 'generated.formats.nif.niphysx.structs.NxJointDriveDesc',
	'NiPhysXJointLimit': 'generated.formats.nif.niphysx.structs.NiPhysXJointLimit',
	'NiPhysXJointDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXJointDesc',
	'NiPhysXD6JointDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXD6JointDesc',
	'NxShapeType': 'generated.formats.nif.enums.NxShapeType',
	'NxShapeFlag': 'generated.formats.nif.bitflagss.NxShapeFlag',
	'NxPlane': 'generated.formats.nif.niphysx.structs.NxPlane',
	'NxCapsule': 'generated.formats.nif.niphysx.structs.NxCapsule',
	'NiPhysXShapeDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXShapeDesc',
	'NiPhysXMeshDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXMeshDesc',
	'NxMaterialFlag': 'generated.formats.nif.bitflagss.NxMaterialFlag',
	'NxSpringDesc': 'generated.formats.nif.niphysx.structs.NxSpringDesc',
	'NxCombineMode': 'generated.formats.nif.enums.NxCombineMode',
	'NxMaterialDesc': 'generated.formats.nif.niphysx.structs.NxMaterialDesc',
	'NiPhysXMaterialDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXMaterialDesc',
	'NxClothFlag': 'generated.formats.nif.bitflagss.NxClothFlag',
	'PhysXClothState': 'generated.formats.nif.niphysx.structs.PhysXClothState',
	'PhysXClothAttachmentPosition': 'generated.formats.nif.niphysx.structs.PhysXClothAttachmentPosition',
	'PhysXClothAttachment': 'generated.formats.nif.niphysx.structs.PhysXClothAttachment',
	'NiPhysXClothDesc': 'generated.formats.nif.niphysx.niobjects.NiPhysXClothDesc',
	'NiPhysXDest': 'generated.formats.nif.niphysx.niobjects.NiPhysXDest',
	'NiPhysXRigidBodyDest': 'generated.formats.nif.niphysx.niobjects.NiPhysXRigidBodyDest',
	'NiPhysXTransformDest': 'generated.formats.nif.niphysx.niobjects.NiPhysXTransformDest',
	'NiPhysXSrc': 'generated.formats.nif.niphysx.niobjects.NiPhysXSrc',
	'NiPhysXRigidBodySrc': 'generated.formats.nif.niphysx.niobjects.NiPhysXRigidBodySrc',
	'NiPhysXKinematicSrc': 'generated.formats.nif.niphysx.niobjects.NiPhysXKinematicSrc',
	'NiPhysXDynamicSrc': 'generated.formats.nif.niphysx.niobjects.NiPhysXDynamicSrc',
	'NiLines': 'generated.formats.nif.nimain.niobjects.NiLines',
	'NiLinesData': 'generated.formats.nif.nimain.niobjects.NiLinesData',
	'Polygon': 'generated.formats.nif.nimain.structs.Polygon',
	'NiScreenElementsData': 'generated.formats.nif.nimain.niobjects.NiScreenElementsData',
	'NiScreenElements': 'generated.formats.nif.nimain.niobjects.NiScreenElements',
	'NiRoomGroup': 'generated.formats.nif.nimain.niobjects.NiRoomGroup',
	'NiWall': 'generated.formats.nif.nimain.niobjects.NiWall',
	'NiRoom': 'generated.formats.nif.nimain.niobjects.NiRoom',
	'NiPortal': 'generated.formats.nif.nimain.niobjects.NiPortal',
	'BSFadeNode': 'generated.formats.nif.bsmain.niobjects.BSFadeNode',
	'BSShaderType': 'generated.formats.nif.enums.BSShaderType',
	'BSShaderFlags': 'generated.formats.nif.bitflagss.BSShaderFlags',
	'BSShaderFlags2': 'generated.formats.nif.bitflagss.BSShaderFlags2',
	'BSShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSShaderProperty',
	'BSShaderLightingProperty': 'generated.formats.nif.bsmain.niobjects.BSShaderLightingProperty',
	'BSShaderNoLightingProperty': 'generated.formats.nif.bsmain.niobjects.BSShaderNoLightingProperty',
	'BSShaderPPLightingProperty': 'generated.formats.nif.bsmain.niobjects.BSShaderPPLightingProperty',
	'BSEffectShaderPropertyFloatController': 'generated.formats.nif.bsanimation.niobjects.BSEffectShaderPropertyFloatController',
	'BSEffectShaderPropertyColorController': 'generated.formats.nif.bsanimation.niobjects.BSEffectShaderPropertyColorController',
	'BSLightingShaderPropertyFloatController': 'generated.formats.nif.bsanimation.niobjects.BSLightingShaderPropertyFloatController',
	'BSLightingShaderPropertyUShortController': 'generated.formats.nif.bsanimation.niobjects.BSLightingShaderPropertyUShortController',
	'BSLightingShaderPropertyColorController': 'generated.formats.nif.bsanimation.niobjects.BSLightingShaderPropertyColorController',
	'BSNiAlphaPropertyTestRefController': 'generated.formats.nif.bsanimation.niobjects.BSNiAlphaPropertyTestRefController',
	'BSProceduralLightningController': 'generated.formats.nif.bsanimation.niobjects.BSProceduralLightningController',
	'BSShaderTextureSet': 'generated.formats.nif.bsmain.niobjects.BSShaderTextureSet',
	'WaterShaderProperty': 'generated.formats.nif.bsmain.niobjects.WaterShaderProperty',
	'SkyObjectType': 'generated.formats.nif.enums.SkyObjectType',
	'SkyShaderProperty': 'generated.formats.nif.bsmain.niobjects.SkyShaderProperty',
	'TileShaderProperty': 'generated.formats.nif.bsmain.niobjects.TileShaderProperty',
	'DistantLODShaderProperty': 'generated.formats.nif.bsmain.niobjects.DistantLODShaderProperty',
	'BSDistantTreeShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSDistantTreeShaderProperty',
	'TallGrassShaderProperty': 'generated.formats.nif.bsmain.niobjects.TallGrassShaderProperty',
	'VolumetricFogShaderProperty': 'generated.formats.nif.bsmain.niobjects.VolumetricFogShaderProperty',
	'HairShaderProperty': 'generated.formats.nif.bsmain.niobjects.HairShaderProperty',
	'Lighting30ShaderProperty': 'generated.formats.nif.bsmain.niobjects.Lighting30ShaderProperty',
	'SkyrimShaderPropertyFlags1': 'generated.formats.nif.bitflagss.SkyrimShaderPropertyFlags1',
	'SkyrimShaderPropertyFlags2': 'generated.formats.nif.bitflagss.SkyrimShaderPropertyFlags2',
	'Fallout4ShaderPropertyFlags1': 'generated.formats.nif.bitflagss.Fallout4ShaderPropertyFlags1',
	'Fallout4ShaderPropertyFlags2': 'generated.formats.nif.bitflagss.Fallout4ShaderPropertyFlags2',
	'BSTextureArray': 'generated.formats.nif.bsmain.structs.BSTextureArray',
	'BSShaderCRC32': 'generated.formats.nif.enums.BSShaderCRC32',
	'BSSPWetnessParams': 'generated.formats.nif.bsmain.structs.BSSPWetnessParams',
	'BSSPLuminanceParams': 'generated.formats.nif.bsmain.structs.BSSPLuminanceParams',
	'BSSPTranslucencyParams': 'generated.formats.nif.bsmain.structs.BSSPTranslucencyParams',
	'BSLightingShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSLightingShaderProperty',
	'BSEffectShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSEffectShaderProperty',
	'WaterShaderPropertyFlags': 'generated.formats.nif.bitflagss.WaterShaderPropertyFlags',
	'BSWaterShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSWaterShaderProperty',
	'BSSkyShaderProperty': 'generated.formats.nif.bsmain.niobjects.BSSkyShaderProperty',
	'BSDismemberSkinInstance': 'generated.formats.nif.bsmain.niobjects.BSDismemberSkinInstance',
	'BSDecalPlacementVectorExtraData': 'generated.formats.nif.bsmain.niobjects.BSDecalPlacementVectorExtraData',
	'BSPSysSimpleColorModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysSimpleColorModifier',
	'BSValueNodeFlags': 'generated.formats.nif.bitflagss.BSValueNodeFlags',
	'BSValueNode': 'generated.formats.nif.bsmain.niobjects.BSValueNode',
	'BSStripParticleSystem': 'generated.formats.nif.bsparticle.niobjects.BSStripParticleSystem',
	'BSStripPSysData': 'generated.formats.nif.bsparticle.niobjects.BSStripPSysData',
	'BSPSysStripUpdateModifier': 'generated.formats.nif.bsparticle.niobjects.BSPSysStripUpdateModifier',
	'BSMaterialEmittanceMultController': 'generated.formats.nif.bsanimation.niobjects.BSMaterialEmittanceMultController',
	'BSMasterParticleSystem': 'generated.formats.nif.bsparticle.niobjects.BSMasterParticleSystem',
	'BSPSysMultiTargetEmitterCtlr': 'generated.formats.nif.bsparticle.niobjects.BSPSysMultiTargetEmitterCtlr',
	'BSRefractionStrengthController': 'generated.formats.nif.bsanimation.niobjects.BSRefractionStrengthController',
	'BSOrderedNode': 'generated.formats.nif.bsmain.niobjects.BSOrderedNode',
	'BSRangeNode': 'generated.formats.nif.bsmain.niobjects.BSRangeNode',
	'BSBlastNode': 'generated.formats.nif.bsmain.niobjects.BSBlastNode',
	'BSDamageStage': 'generated.formats.nif.bsmain.niobjects.BSDamageStage',
	'BSRefractionFirePeriodController': 'generated.formats.nif.bsanimation.niobjects.BSRefractionFirePeriodController',
	'BhkConvexListShape': 'generated.formats.nif.bshavok.niobjects.BhkConvexListShape',
	'BSTreadTransform': 'generated.formats.nif.bsanimation.structs.BSTreadTransform',
	'BSTreadTransfInterpolator': 'generated.formats.nif.bsanimation.niobjects.BSTreadTransfInterpolator',
	'AnimNoteType': 'generated.formats.nif.enums.AnimNoteType',
	'BSAnimNote': 'generated.formats.nif.bsanimation.niobjects.BSAnimNote',
	'BSAnimNotes': 'generated.formats.nif.bsanimation.niobjects.BSAnimNotes',
	'BhkLiquidAction': 'generated.formats.nif.bshavok.niobjects.BhkLiquidAction',
	'BSCPCullingType': 'generated.formats.nif.enums.BSCPCullingType',
	'BSMultiBoundNode': 'generated.formats.nif.bsmain.niobjects.BSMultiBoundNode',
	'BSMultiBound': 'generated.formats.nif.bsmain.niobjects.BSMultiBound',
	'BSMultiBoundData': 'generated.formats.nif.bsmain.niobjects.BSMultiBoundData',
	'BSMultiBoundOBB': 'generated.formats.nif.bsmain.niobjects.BSMultiBoundOBB',
	'BSMultiBoundSphere': 'generated.formats.nif.bsmain.niobjects.BSMultiBoundSphere',
	'BSGeometrySubSegment': 'generated.formats.nif.bsmain.structs.BSGeometrySubSegment',
	'BSGeometrySegmentData': 'generated.formats.nif.bsmain.structs.BSGeometrySegmentData',
	'BSSegmentedTriShape': 'generated.formats.nif.bsmain.niobjects.BSSegmentedTriShape',
	'BSMultiBoundAABB': 'generated.formats.nif.bsmain.niobjects.BSMultiBoundAABB',
	'NiAGDDataStream': 'generated.formats.nif.nimain.structs.NiAGDDataStream',
	'NiAGDDataBlock': 'generated.formats.nif.nimain.structs.NiAGDDataBlock',
	'NiAGDDataBlocks': 'generated.formats.nif.nimain.structs.NiAGDDataBlocks',
	'NiAdditionalGeometryData': 'generated.formats.nif.nimain.niobjects.NiAdditionalGeometryData',
	'BSPackedAdditionalGeometryData': 'generated.formats.nif.bsmain.niobjects.BSPackedAdditionalGeometryData',
	'BSWArray': 'generated.formats.nif.bsmain.niobjects.BSWArray',
	'BSFrustumFOVController': 'generated.formats.nif.bsanimation.niobjects.BSFrustumFOVController',
	'BSDebrisNode': 'generated.formats.nif.bsmain.niobjects.BSDebrisNode',
	'BhkBreakableConstraint': 'generated.formats.nif.bshavok.niobjects.BhkBreakableConstraint',
	'BhkOrientHingedBodyAction': 'generated.formats.nif.bshavok.niobjects.BhkOrientHingedBodyAction',
	'BhkPoseArray': 'generated.formats.nif.bshavok.niobjects.BhkPoseArray',
	'BhkRagdollTemplate': 'generated.formats.nif.bshavok.niobjects.BhkRagdollTemplate',
	'BhkRagdollTemplateData': 'generated.formats.nif.bshavok.niobjects.BhkRagdollTemplateData',
	'Region': 'generated.formats.nif.nimesh.structs.Region',
	'CloningBehavior': 'generated.formats.nif.nimesh.enums.CloningBehavior',
	'ComponentFormat': 'generated.formats.nif.enums.ComponentFormat',
	'DataStreamUsage': 'generated.formats.nif.enums.DataStreamUsage',
	'DataStreamAccess': 'generated.formats.nif.bitflagss.DataStreamAccess',
	'DataStreamData': 'generated.formats.nif.nimesh.structs.DataStreamData',
	'NiDataStream': 'generated.formats.nif.nimesh.niobjects.NiDataStream',
	'SemanticData': 'generated.formats.nif.nimesh.structs.SemanticData',
	'DataStreamRef': 'generated.formats.nif.nimesh.structs.DataStreamRef',
	'NiRenderObject': 'generated.formats.nif.nimain.niobjects.NiRenderObject',
	'MeshPrimitiveType': 'generated.formats.nif.enums.MeshPrimitiveType',
	'SyncPoint': 'generated.formats.nif.enums.SyncPoint',
	'NiMeshModifier': 'generated.formats.nif.nimesh.niobjects.NiMeshModifier',
	'MeshDataEpicMickey': 'generated.formats.nif.nimesh.structs.MeshDataEpicMickey',
	'WeightDataEpicMickey': 'generated.formats.nif.nimesh.structs.WeightDataEpicMickey',
	'PartitionDataEpicMickey': 'generated.formats.nif.nimesh.structs.PartitionDataEpicMickey',
	'ExtraMeshDataEpicMickey': 'generated.formats.nif.nimesh.structs.ExtraMeshDataEpicMickey',
	'NiMesh': 'generated.formats.nif.nimesh.niobjects.NiMesh',
	'NiMorphWeightsController': 'generated.formats.nif.nianimation.niobjects.NiMorphWeightsController',
	'ElementReference': 'generated.formats.nif.nimesh.structs.ElementReference',
	'NiMorphMeshModifier': 'generated.formats.nif.nimesh.niobjects.NiMorphMeshModifier',
	'NiSkinningMeshModifier': 'generated.formats.nif.nimesh.niobjects.NiSkinningMeshModifier',
	'NiMeshHWInstance': 'generated.formats.nif.nimesh.niobjects.NiMeshHWInstance',
	'NiInstancingMeshModifier': 'generated.formats.nif.nimesh.niobjects.NiInstancingMeshModifier',
	'LODInfo': 'generated.formats.nif.nianimation.structs.LODInfo',
	'NiSkinningLODController': 'generated.formats.nif.nianimation.niobjects.NiSkinningLODController',
	'PSSpawnRateKey': 'generated.formats.nif.nipsparticle.structs.PSSpawnRateKey',
	'AlignMethod': 'generated.formats.nif.enums.AlignMethod',
	'NiPSParticleSystem': 'generated.formats.nif.nipsparticle.niobjects.NiPSParticleSystem',
	'NiPSMeshParticleSystem': 'generated.formats.nif.nipsparticle.niobjects.NiPSMeshParticleSystem',
	'NiPSFacingQuadGenerator': 'generated.formats.nif.nipsparticle.niobjects.NiPSFacingQuadGenerator',
	'NiPSAlignedQuadGenerator': 'generated.formats.nif.nipsparticle.niobjects.NiPSAlignedQuadGenerator',
	'NiPSSimulator': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulator',
	'NiPSSimulatorStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorStep',
	'PSLoopBehavior': 'generated.formats.nif.enums.PSLoopBehavior',
	'NiPSSimulatorGeneralStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorGeneralStep',
	'NiPSSimulatorForcesStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorForcesStep',
	'NiPSSimulatorCollidersStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorCollidersStep',
	'NiPSSimulatorMeshAlignStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorMeshAlignStep',
	'NiPSSimulatorFinalStep': 'generated.formats.nif.nipsparticle.niobjects.NiPSSimulatorFinalStep',
	'NiPSBoundUpdater': 'generated.formats.nif.nipsparticle.niobjects.NiPSBoundUpdater',
	'PSForceType': 'generated.formats.nif.enums.PSForceType',
	'NiPSForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSForce',
	'NiPSFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSFieldForce',
	'NiPSDragForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSDragForce',
	'NiPSGravityForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSGravityForce',
	'NiPSBombForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSBombForce',
	'NiPSAirFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSAirFieldForce',
	'NiPSGravityFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSGravityFieldForce',
	'NiPSDragFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSDragFieldForce',
	'NiPSRadialFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSRadialFieldForce',
	'NiPSTurbulenceFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSTurbulenceFieldForce',
	'NiPSVortexFieldForce': 'generated.formats.nif.nipsparticle.niobjects.NiPSVortexFieldForce',
	'NiPSEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitter',
	'NiPSVolumeEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSVolumeEmitter',
	'NiPSBoxEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSBoxEmitter',
	'NiPSSphereEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSSphereEmitter',
	'NiPSCylinderEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSCylinderEmitter',
	'NiPSTorusEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSTorusEmitter',
	'NiPSMeshEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSMeshEmitter',
	'NiPSCurveEmitter': 'generated.formats.nif.nipsparticle.niobjects.NiPSCurveEmitter',
	'NiPSEmitterCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterCtlr',
	'NiPSEmitterFloatCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterFloatCtlr',
	'NiPSEmitParticlesCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitParticlesCtlr',
	'NiPSForceCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSForceCtlr',
	'NiPSForceBoolCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSForceBoolCtlr',
	'NiPSForceFloatCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSForceFloatCtlr',
	'NiPSForceActiveCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSForceActiveCtlr',
	'NiPSGravityStrengthCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSGravityStrengthCtlr',
	'NiPSFieldAttenuationCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSFieldAttenuationCtlr',
	'NiPSFieldMagnitudeCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSFieldMagnitudeCtlr',
	'NiPSFieldMaxDistanceCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSFieldMaxDistanceCtlr',
	'NiPSEmitterSpeedCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterSpeedCtlr',
	'NiPSEmitterRadiusCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterRadiusCtlr',
	'NiPSEmitterDeclinationCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterDeclinationCtlr',
	'NiPSEmitterDeclinationVarCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterDeclinationVarCtlr',
	'NiPSEmitterPlanarAngleCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterPlanarAngleCtlr',
	'NiPSEmitterPlanarAngleVarCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterPlanarAngleVarCtlr',
	'NiPSEmitterRotAngleCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterRotAngleCtlr',
	'NiPSEmitterRotAngleVarCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterRotAngleVarCtlr',
	'NiPSEmitterRotSpeedCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterRotSpeedCtlr',
	'NiPSEmitterRotSpeedVarCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterRotSpeedVarCtlr',
	'NiPSEmitterLifeSpanCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSEmitterLifeSpanCtlr',
	'NiPSResetOnLoopCtlr': 'generated.formats.nif.nipsparticle.niobjects.NiPSResetOnLoopCtlr',
	'ColliderType': 'generated.formats.nif.enums.ColliderType',
	'NiPSCollider': 'generated.formats.nif.nipsparticle.niobjects.NiPSCollider',
	'NiPSPlanarCollider': 'generated.formats.nif.nipsparticle.niobjects.NiPSPlanarCollider',
	'NiPSSphericalCollider': 'generated.formats.nif.nipsparticle.niobjects.NiPSSphericalCollider',
	'NiPSSpawner': 'generated.formats.nif.nipsparticle.niobjects.NiPSSpawner',
	'NiPhysXPSParticleSystem': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSParticleSystem',
	'NiPhysXPSParticleSystemProp': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSParticleSystemProp',
	'NiPhysXPSParticleSystemDest': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSParticleSystemDest',
	'NiPhysXPSSimulator': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSSimulator',
	'NiPhysXPSSimulatorInitialStep': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSSimulatorInitialStep',
	'NiPhysXPSSimulatorFinalStep': 'generated.formats.nif.niphysx.niobjects.NiPhysXPSSimulatorFinalStep',
	'NiEvaluator': 'generated.formats.nif.nianimation.niobjects.NiEvaluator',
	'NiKeyBasedEvaluator': 'generated.formats.nif.nianimation.niobjects.NiKeyBasedEvaluator',
	'NiBoolEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBoolEvaluator',
	'NiBoolTimelineEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBoolTimelineEvaluator',
	'NiColorEvaluator': 'generated.formats.nif.nianimation.niobjects.NiColorEvaluator',
	'NiFloatEvaluator': 'generated.formats.nif.nianimation.niobjects.NiFloatEvaluator',
	'NiPoint3Evaluator': 'generated.formats.nif.nianimation.niobjects.NiPoint3Evaluator',
	'NiQuaternionEvaluator': 'generated.formats.nif.nianimation.niobjects.NiQuaternionEvaluator',
	'NiTransformEvaluator': 'generated.formats.nif.nianimation.niobjects.NiTransformEvaluator',
	'NiConstBoolEvaluator': 'generated.formats.nif.nianimation.niobjects.NiConstBoolEvaluator',
	'NiConstColorEvaluator': 'generated.formats.nif.nianimation.niobjects.NiConstColorEvaluator',
	'NiConstFloatEvaluator': 'generated.formats.nif.nianimation.niobjects.NiConstFloatEvaluator',
	'NiConstPoint3Evaluator': 'generated.formats.nif.nianimation.niobjects.NiConstPoint3Evaluator',
	'NiConstQuaternionEvaluator': 'generated.formats.nif.nianimation.niobjects.NiConstQuaternionEvaluator',
	'NiConstTransformEvaluator': 'generated.formats.nif.nianimation.niobjects.NiConstTransformEvaluator',
	'NiBSplineEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineEvaluator',
	'NiBSplineColorEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineColorEvaluator',
	'NiBSplineCompColorEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompColorEvaluator',
	'NiBSplineFloatEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineFloatEvaluator',
	'NiBSplineCompFloatEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompFloatEvaluator',
	'NiBSplinePoint3Evaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplinePoint3Evaluator',
	'NiBSplineCompPoint3Evaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompPoint3Evaluator',
	'NiBSplineTransformEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineTransformEvaluator',
	'NiBSplineCompTransformEvaluator': 'generated.formats.nif.nianimation.niobjects.NiBSplineCompTransformEvaluator',
	'NiLookAtEvaluator': 'generated.formats.nif.nianimation.niobjects.NiLookAtEvaluator',
	'NiPathEvaluator': 'generated.formats.nif.nianimation.niobjects.NiPathEvaluator',
	'NiSequenceData': 'generated.formats.nif.nianimation.niobjects.NiSequenceData',
	'NiShadowGeneratorFlags': 'generated.formats.nif.bitflagss.NiShadowGeneratorFlags',
	'NiShadowGenerator': 'generated.formats.nif.nimain.niobjects.NiShadowGenerator',
	'NiFurSpringController': 'generated.formats.nif.nicustom.niobjects.NiFurSpringController',
	'CStreamableAssetData': 'generated.formats.nif.nicustom.niobjects.CStreamableAssetData',
	'JPSJigsawNode': 'generated.formats.nif.nimesh.niobjects.JPSJigsawNode',
	'BhkCompressedMeshShape': 'generated.formats.nif.bshavok.niobjects.BhkCompressedMeshShape',
	'HkWeldingType': 'generated.formats.nif.enums.HkWeldingType',
	'BhkCMSMatType': 'generated.formats.nif.bshavok.enums.BhkCMSMatType',
	'BhkCompressedMeshShapeData': 'generated.formats.nif.bshavok.niobjects.BhkCompressedMeshShapeData',
	'BSInvMarker': 'generated.formats.nif.bsmain.niobjects.BSInvMarker',
	'BSBoneLODExtraData': 'generated.formats.nif.bsmain.niobjects.BSBoneLODExtraData',
	'BSBehaviorGraphExtraData': 'generated.formats.nif.bsmain.niobjects.BSBehaviorGraphExtraData',
	'BSLagBoneController': 'generated.formats.nif.bsanimation.niobjects.BSLagBoneController',
	'BSLODTriShape': 'generated.formats.nif.bsmain.niobjects.BSLODTriShape',
	'BSFurnitureMarkerNode': 'generated.formats.nif.bsmain.niobjects.BSFurnitureMarkerNode',
	'BSLeafAnimNode': 'generated.formats.nif.bsmain.niobjects.BSLeafAnimNode',
	'BSTreeNode': 'generated.formats.nif.bsmain.niobjects.BSTreeNode',
	'BSTriShape': 'generated.formats.nif.bsmain.niobjects.BSTriShape',
	'BSMeshLODTriShape': 'generated.formats.nif.bsmain.niobjects.BSMeshLODTriShape',
	'BSGeometryPerSegmentSharedData': 'generated.formats.nif.bsmain.structs.BSGeometryPerSegmentSharedData',
	'BSGeometrySegmentSharedData': 'generated.formats.nif.bsmain.structs.BSGeometrySegmentSharedData',
	'BSSubIndexTriShape': 'generated.formats.nif.bsmain.niobjects.BSSubIndexTriShape',
	'BhkSystem': 'generated.formats.nif.bshavok.niobjects.BhkSystem',
	'BhkNPCollisionObject': 'generated.formats.nif.bshavok.niobjects.BhkNPCollisionObject',
	'BhkPhysicsSystem': 'generated.formats.nif.bshavok.niobjects.BhkPhysicsSystem',
	'BhkRagdollSystem': 'generated.formats.nif.bshavok.niobjects.BhkRagdollSystem',
	'BSExtraData': 'generated.formats.nif.bsmain.niobjects.BSExtraData',
	'BSClothExtraData': 'generated.formats.nif.bsmain.niobjects.BSClothExtraData',
	'BSSkinBoneTrans': 'generated.formats.nif.bsmain.structs.BSSkinBoneTrans',
	'BSSkinInstance': 'generated.formats.nif.bsmain.niobjects.BSSkinInstance',
	'BSSkinBoneData': 'generated.formats.nif.bsmain.niobjects.BSSkinBoneData',
	'BSPositionData': 'generated.formats.nif.bsmain.niobjects.BSPositionData',
	'BSConnectPoint': 'generated.formats.nif.bsmain.structs.BSConnectPoint',
	'BSConnectPointParents': 'generated.formats.nif.bsmain.niobjects.BSConnectPointParents',
	'BSConnectPointChildren': 'generated.formats.nif.bsmain.niobjects.BSConnectPointChildren',
	'BSEyeCenterExtraData': 'generated.formats.nif.bsmain.niobjects.BSEyeCenterExtraData',
	'BSPackedGeomDataCombined': 'generated.formats.nif.bsmain.structs.BSPackedGeomDataCombined',
	'BSPackedGeomData': 'generated.formats.nif.bsmain.structs.BSPackedGeomData',
	'BSPackedSharedGeomData': 'generated.formats.nif.bsmain.structs.BSPackedSharedGeomData',
	'BSPackedGeomObject': 'generated.formats.nif.bsmain.structs.BSPackedGeomObject',
	'BSPackedCombinedGeomDataExtra': 'generated.formats.nif.bsmain.niobjects.BSPackedCombinedGeomDataExtra',
	'BSPackedCombinedSharedGeomDataExtra': 'generated.formats.nif.bsmain.niobjects.BSPackedCombinedSharedGeomDataExtra',
	'NiLightRadiusController': 'generated.formats.nif.bsanimation.niobjects.NiLightRadiusController',
	'BSDynamicTriShape': 'generated.formats.nif.bsmain.niobjects.BSDynamicTriShape',
	'BSDistantObjectLargeRefExtraData': 'generated.formats.nif.bsmain.niobjects.BSDistantObjectLargeRefExtraData',
	'BSDistantObjectExtraData': 'generated.formats.nif.bsmain.niobjects.BSDistantObjectExtraData',
	'BSResourceID': 'generated.formats.nif.bsmain.structs.BSResourceID',
	'BSDistantObjectUnknown': 'generated.formats.nif.bsmain.structs.BSDistantObjectUnknown',
	'BSDistantObjectInstance': 'generated.formats.nif.bsmain.structs.BSDistantObjectInstance',
	'BSShaderTextureArray': 'generated.formats.nif.bsmain.structs.BSShaderTextureArray',
	'BSDistantObjectInstancedNode': 'generated.formats.nif.bsmain.niobjects.BSDistantObjectInstancedNode',
	'BSCollisionQueryProxyExtraData': 'generated.formats.nif.bsmain.niobjects.BSCollisionQueryProxyExtraData',
	'CsNiNode': 'generated.formats.nif.niobjects.CsNiNode',
	'NiYAMaterialProperty': 'generated.formats.nif.nimain.niobjects.NiYAMaterialProperty',
	'NiRimLightProperty': 'generated.formats.nif.nimain.niobjects.NiRimLightProperty',
	'QQSpeedLODEntry': 'generated.formats.nif.structs.QQSpeedLODEntry',
	'NiProgramLODData': 'generated.formats.nif.nimain.niobjects.NiProgramLODData',
	'MdlManCDataEntry': 'generated.formats.nif.niobjects.MdlManCDataEntry',
	'MdlManCModelTemplateDataEntry': 'generated.formats.nif.niobjects.MdlManCModelTemplateDataEntry',
	'MdlManCAMDataEntry': 'generated.formats.nif.niobjects.MdlManCAMDataEntry',
	'MdlManCMeshDataEntry': 'generated.formats.nif.niobjects.MdlManCMeshDataEntry',
	'MdlManCSkeletonDataEntry': 'generated.formats.nif.niobjects.MdlManCSkeletonDataEntry',
	'MdlManCAnimationDataEntry': 'generated.formats.nif.niobjects.MdlManCAnimationDataEntry',
}

name_type_map = {}
for type_name, module in type_module_name_map.items():
	name_type_map[type_name] = getattr(import_module(module), type_name)
for class_object in name_type_map.values():
	if callable(getattr(class_object, 'init_attributes', None)):
		class_object.init_attributes()
