from generated.array import Array
from generated.formats.nif.imports import name_type_map
from generated.formats.nif.nimain.niobjects.NiExtraData import NiExtraData


class NiIntegersExtraData(NiExtraData):

	"""
	Extra integer array data.
	"""

	__name__ = 'NiIntegersExtraData'


	def __init__(self, context, arg=0, template=None, set_default=True):
		super().__init__(context, arg, template, set_default=False)

		# Number of integers.
		self.num_integers = name_type_map['Uint'](self.context, 0, None)

		# Integers.
		self.data = Array(self.context, 0, None, (0,), name_type_map['Uint'])
		if set_default:
			self.set_defaults()

	@classmethod
	def _get_attribute_list(cls):
		yield from super()._get_attribute_list()
		yield 'num_integers', name_type_map['Uint'], (0, None), (False, None), (None, None)
		yield 'data', Array, (0, None, (None,), name_type_map['Uint']), (False, None), (None, None)

	@classmethod
	def _get_filtered_attribute_list(cls, instance, include_abstract=True):
		yield from super()._get_filtered_attribute_list(instance, include_abstract)
		yield 'num_integers', name_type_map['Uint'], (0, None), (False, None)
		yield 'data', Array, (0, None, (instance.num_integers,), name_type_map['Uint']), (False, None)
