from generated.base_struct import BaseStruct
from generated.formats.nif.imports import name_type_map


class ElementReference(BaseStruct):

	__name__ = 'ElementReference'


	def __init__(self, context, arg=0, template=None, set_default=True):
		super().__init__(context, arg, template, set_default=False)

		# The element semantic.
		self.semantic = name_type_map['SemanticData'](self.context, 0, None)

		# Whether or not to normalize the data.
		self.normalize_flag = name_type_map['Uint'](self.context, 0, None)
		if set_default:
			self.set_defaults()

	@classmethod
	def _get_attribute_list(cls):
		yield from super()._get_attribute_list()
		yield 'semantic', name_type_map['SemanticData'], (0, None), (False, None), (None, None)
		yield 'normalize_flag', name_type_map['Uint'], (0, None), (False, None), (None, None)

	@classmethod
	def _get_filtered_attribute_list(cls, instance, include_abstract=True):
		yield from super()._get_filtered_attribute_list(instance, include_abstract)
		yield 'semantic', name_type_map['SemanticData'], (0, None), (False, None)
		yield 'normalize_flag', name_type_map['Uint'], (0, None), (False, None)
