from generated.formats.nif.imports import name_type_map
from generated.formats.nif.niparticle.niobjects.NiPSysEmitter import NiPSysEmitter


class NiPSysVolumeEmitter(NiPSysEmitter):

	"""
	Abstract base class for particle emitters that emit particles from a volume.
	"""

	__name__ = 'NiPSysVolumeEmitter'


	def __init__(self, context, arg=0, template=None, set_default=True):
		super().__init__(context, arg, template, set_default=False)

		# Node parent of this modifier?
		self.emitter_object = name_type_map['Ptr'](self.context, 0, name_type_map['NiNode'])
		if set_default:
			self.set_defaults()

	@classmethod
	def _get_attribute_list(cls):
		yield from super()._get_attribute_list()
		yield 'emitter_object', name_type_map['Ptr'], (0, name_type_map['NiNode']), (False, None), (lambda context: context.version >= 167837696, None)

	@classmethod
	def _get_filtered_attribute_list(cls, instance, include_abstract=True):
		yield from super()._get_filtered_attribute_list(instance, include_abstract)
		if instance.context.version >= 167837696:
			yield 'emitter_object', name_type_map['Ptr'], (0, name_type_map['NiNode']), (False, None)
